ALTER TABLE PRIKLJ
ADD NNPRIKLJ_ID NUMBER
;

UPDATE PRIKLJ
SET NNPRIKLJ_ID = (SELECT NNPRIKLJ_ID FROM NNPRIKLJ WHERE PRIKLJ.OZNAKA=NNPRIKLJ.OZNAKA AND PRIKLJ.PRIKLJUCEK=NNPRIKLJ.PRIKLJ)
WHERE NNPRIKLJ_ID IS NULL
;

alter table PRIKLJ
add constraint FK_PRIKLJ_NNPRIKLJ foreign key  (NNPRIKLJ_ID)
references NNPRIKLJ (NNPRIKLJ_ID)
;

DROP VIEW V_PRIKLJ;

CREATE OR REPLACE VIEW V_PRIKLJ AS (
  SELECT P.ID_PRIKLJ, P.ID_LASTNIKA, P.ID_PLOVILA, P.ID, P.ID_STORITVE, P.OZNAKA, P.PRIKLJUCEK, P.DATUM_ZACETKA, P.DATUM_KONCA, P.ZACETNO_STANJE, P.KONCNO_STANJE, P.ZASEDEN, P.OBRACUNAN, P.STEVEC_HW_STANJE, 
  P.KONCNO_STANJE - P.ZACETNO_STANJE AS USED_AMOUNT,
  N.OPIS AS NPRIKLJ_OPIS, NN.ZACETNO_STANJE AS NNPRIKLJ_ZACETNO_STANJE, NN.KONCNO_STANJE AS NNPRIKLJ_KONCNO_STANJE, NN.ZASEDEN AS NNPRIKLJ_ZASEDEN, NN.OPIS AS NNPRIKLJ_OPIS, NN.EXT_DATE AS NNPRIKLJ_EXT_DATE,
  NN.EXT_PONTOON AS NNPRIKLJ_EXT_PONTOON, NN.EXT_SOCKET AS NNPRIKLJ_EXT_SOCKET, NN.NNPRIKLJ_ID AS NNPRIKLJ_ID,
  NNP.ID_PRIVEZ AS NNPRIVEZ_ID_PRIVEZ, NNP.OBJEKT AS NNPRIVEZ_OBJEKT, NNP.N_PRIVEZA AS NNPRIVEZ_N_PRIVEZA, K.PRIIMEK AS KUPCI_PRIIMEK, K.IME AS KUPCI_IME, PL.IME AS PLOVILA_IME, NNL.ID AS NNLOCATION_ID,
  C.BRUTO_DOMACA_VALUTA AS PRICE_PER_UNIT, (P.KONCNO_STANJE - P.ZACETNO_STANJE)*C.BRUTO_DOMACA_VALUTA*COALESCE(N.METER_RATIO, 1) AS PRICE_USED_AMOUNT
  FROM PRIKLJ P
  LEFT OUTER JOIN NPRIKLJ N ON P.OZNAKA=N.SIFRA
  LEFT OUTER JOIN NNPRIKLJ NN ON P.NNPRIKLJ_ID=NN.NNPRIKLJ_ID
  LEFT OUTER JOIN NNPRIVEZ NNP ON NNP.ID_PRIVEZ = NN.ID_PRIVEZ
  LEFT OUTER JOIN KUPCI K ON P.ID_LASTNIKA = K.ID
  LEFT OUTER JOIN PLOVILA PL ON P.ID_PLOVILA = PL.ID
  LEFT OUTER JOIN NNPOMOL NP ON NP.SIFRA = NNP.KATEGORIJA
  LEFT OUTER JOIN NNLOCATION NNL ON NNL.ID = NP.NNLOCATION_ID
  LEFT OUTER JOIN (SELECT M_NNCENMAR.*, RANK() OVER (PARTITION BY STORITEV ORDER BY ID_M_NNCENMAR DESC) RNK FROM M_NNCENMAR) C ON (C.STORITEV = N.STORITEV AND (C.NNLOCATION_ID IS NULL OR C.NNLOCATION_ID = NP.NNLOCATION_ID) AND C.RNK = 1)
);

DROP VIEW V_NNPRIKLJ
;

CREATE OR REPLACE VIEW V_NNPRIKLJ AS (
SELECT NN.NNPRIKLJ_ID, NN.ID_PRIVEZ, NN.OZNAKA, NN.PRIKLJ, NN.ZACETNO_STANJE, NN.KONCNO_STANJE, NN.ZASEDEN, NN.INTERNI_OPIS, NN.OPIS, NN.EXT_DATE AS NNPRIKLJ_EXT_DATE, NN.EXT_PONTOON, NN.EXT_SOCKET, 
NN.VOLTAGE, NN.AMPERAGE, NN.EUUS, NN.METER_HW_VALUE, NN.EXT_ID,
N.OPIS AS NPRIKLJ_OPIS, N.INTERNI_OPIS AS NPRIKLJ_INTERNI_OPIS, N.STORITEV AS NPRIKLJ_STORITEV, N.NPRIKLJ_TYPE AS NPRIKLJ_TYPE,
P.ID_PRIKLJ AS PRIKLJ_ID_PRIKLJ, P.ID_LASTNIKA AS PRIKLJ_ID_LASTNIKA, P.ID_PLOVILA AS PRIKLJ_ID_PLOVILA, P.ID AS PRIKLJ_ID, P.ID_STORITVE AS PRIKLJ_ID_STORITVE, P.OZNAKA AS PRIKLJ_OZNAKA, 
P.PRIKLJUCEK AS PRIKLJ_PRIKLJUCEK, P.DATUM_ZACETKA AS PRIKLJ_DATUM_ZACETKA, P.DATUM_KONCA AS PRIKLJ_DATUM_KONCA, P.ZACETNO_STANJE AS PRIKLJ_ZACETNO_STANJE, P.KONCNO_STANJE AS PRIKLJ_KONCNO_STANJE, 
P.ZASEDEN AS PRIKLJ_ZASEDEN, P.OBRACUNAN AS PRIKLJ_OBRACUNAN, P.STEVEC_HW_STANJE AS PRIKLJ_STEVEC_HW_STANJE,
NNP.OBJEKT AS NNPRIVEZ_OBJEKT, NNP.N_PRIVEZA AS NNPRIVEZ_N_PRIVEZA, NNP.KATEGORIJA AS NNPRIVEZ_KATEGORIJA, NNP.SORT_PRIKAZ AS NNPRIVEZ_SORT_PRIKAZ, NNPOM.SORT AS NNPOMOL_SORT,
K.PRIIMEK AS KUPCI_PRIIMEK, K.IME AS KUPCI_IME, PL.IME AS PLOVILA_IME, VPL.NNLOCATION_ID, VOL.OPIS AS VOLTAGE_OPIS, AMP.OPIS AS AMPERAGE_OPIS, EUS.OPIS AS EUUS_OPIS,
(SELECT MAX(PR.ZACETNO_STANJE) FROM PRIKLJ PR WHERE PR.NNPRIKLJ_ID = NN.NNPRIKLJ_ID) AS PREVIOUS_STATE
FROM NNPRIKLJ NN
JOIN (SELECT NNI.NNPRIKLJ_ID, CASE WHEN (NNI.ZASEDEN = 'Y') THEN (SELECT MAX(PI.ID_PRIKLJ) FROM PRIKLJ PI WHERE PI.NNPRIKLJ_ID=NNI.NNPRIKLJ_ID) ELSE NULL END AS PRIKLJ_ID FROM NNPRIKLJ NNI) NNI ON NNI.NNPRIKLJ_ID = NN.NNPRIKLJ_ID 
LEFT OUTER JOIN NPRIKLJ N ON NN.OZNAKA=N.SIFRA
LEFT OUTER JOIN NNPRIVEZ NNP ON NNP.ID_PRIVEZ = NN.ID_PRIVEZ
LEFT OUTER JOIN NNPOMOL NNPOM ON NNPOM.SIFRA = NNP.KATEGORIJA
LEFT OUTER JOIN PRIKLJ P ON P.ID_PRIKLJ = NNI.PRIKLJ_ID
LEFT OUTER JOIN KUPCI K ON P.ID_LASTNIKA = K.ID
LEFT OUTER JOIN PLOVILA PL ON P.ID_PLOVILA = PL.ID
LEFT OUTER JOIN V_PRIVEZ_LOCATION VPL ON VPL.ID_PRIVEZ = NN.ID_PRIVEZ
LEFT OUTER JOIN NN_VOLTAGE VOL ON VOL.ID = NN.VOLTAGE
LEFT OUTER JOIN NN_AMPERAGE AMP ON AMP.ID = NN.AMPERAGE
LEFT OUTER JOIN NN_EUUS EUS ON EUS.ID = NN.EUUS
)
;

insert into verzije_baza
(id, dt_vpis, verzija, ver_nr, opis) values (1602, SYSDATE, '5.5', 1522, 'Priklj')
;