CREATE TABLE VOUCHER_TYPE (
  ID_VOUCHER_TYPE NUMBER NOT NULL,
  TYPE NUMBER,
  DESCRIPTION VARCHAR2(200 CHAR),
  ACTIVE VARCHAR2(1 CHAR),
  CONSTRAINT VOUCHER_TYPE_PK PRIMARY KEY (ID_VOUCHER_TYPE)
);

CREATE SEQUENCE VOUCHER_TYPE_SEQ MINVALUE 1 INCREMENT BY 1 START WITH 1 NOCACHE NOORDER  NOCYCLE;

CREATE TABLE VOUCHER (
  ID_VOUCHER NUMBER NOT NULL,
  ID_TYPE NUMBER,
  ID_LASTNIKA NUMBER,
  UNIQUE_NUMBER VARCHAR2(50 CHAR),
  DATE_CREATED DATE,
  EXPIRY_DATE DATE,
  AMOUNT NUMBER,
  USED_AMOUNT NUMBER,
  NNLOCATION_ID NUMBER,
  NOTE VARCHAR2(500 CHAR),
  ACTIVE VARCHAR2(1 CHAR),
  CONSTRAINT VOUCHER_PK PRIMARY KEY (ID_VOUCHER),
  CONSTRAINT VOUCHER_VOUCHER_TYPE_FK FOREIGN KEY (ID_TYPE) REFERENCES VOUCHER_TYPE(ID_VOUCHER_TYPE)
);

CREATE INDEX IX_VOUCHER_ID_TYPE ON VOUCHER (ID_TYPE);

CREATE SEQUENCE VOUCHER_SEQ MINVALUE 1 INCREMENT BY 1 START WITH 1 NOCACHE NOORDER  NOCYCLE;

CREATE OR REPLACE VIEW V_VOUCHER AS (
  SELECT V.ID_VOUCHER, V.ID_TYPE, V.ID_LASTNIKA, V.UNIQUE_NUMBER, V.DATE_CREATED, V.EXPIRY_DATE, V.AMOUNT, V.USED_AMOUNT, V.NNLOCATION_ID, V.NOTE, V.ACTIVE, VT.DESCRIPTION AS TYPE_DESCRIPTION, VT.TYPE AS TYPE_TYPE,
  (CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE FILTER = 'MARINA' AND SEKCIJA = 'MARINA' AND NAZIV = 'ChangeFirstLastName') = '1' THEN (K.IME || ' ' || K.PRIIMEK) ELSE (K.PRIIMEK || ' ' || K.IME) END) AS OWNER
  FROM VOUCHER V
  LEFT OUTER JOIN VOUCHER_TYPE VT ON VT.ID_VOUCHER_TYPE = V.ID_TYPE
  LEFT OUTER JOIN KUPCI K ON K.ID = V.ID_LASTNIKA
);

insert into verzije_baza
(id, dt_vpis, verzija, ver_nr, opis) values (1693, SYSDATE, '5.5', 1613, 'Vouchers')
;